Linux Audio

Check our new training course

Loading...
v6.2
  1#!/bin/sh
  2# SPDX-License-Identifier: GPL-2.0
  3
  4if [ $# -ne 2 ]
  5then
  6	echo "Usage: headers_install.sh INFILE OUTFILE"
  7	echo
  8	echo "Prepares kernel header files for use by user space, by removing"
  9	echo "all compiler.h definitions and #includes, removing any"
 10	echo "#ifdef __KERNEL__ sections, and putting __underscores__ around"
 11	echo "asm/inline/volatile keywords."
 12	echo
 13	echo "INFILE: header file to operate on"
 14	echo "OUTFILE: output file which the processed header is written to"
 
 15
 16	exit 1
 17fi
 18
 19# Grab arguments
 20INFILE=$1
 21OUTFILE=$2
 22TMPFILE=$OUTFILE.tmp
 23
 24trap 'rm -f $OUTFILE $TMPFILE' EXIT
 25
 26# SPDX-License-Identifier with GPL variants must have "WITH Linux-syscall-note"
 27if [ -n "$(sed -n -e "/SPDX-License-Identifier:.*GPL-/{/WITH Linux-syscall-note/!p}" $INFILE)" ]; then
 28	echo "error: $INFILE: missing \"WITH Linux-syscall-note\" for SPDX-License-Identifier" >&2
 29	exit 1
 30fi
 31
 32sed -E -e '
 33	s/([[:space:](])(__user|__force|__iomem)[[:space:]]/\1/g
 34	s/__attribute_const__([[:space:]]|$)/\1/g
 35	s@^#include <linux/compiler(|_types).h>@@
 36	s/(^|[^a-zA-Z0-9])__packed([^a-zA-Z0-9_]|$)/\1__attribute__((packed))\2/g
 37	s/(^|[[:space:](])(inline|asm|volatile)([[:space:](]|$)/\1__\2__\3/g
 38	s@#(ifndef|define|endif[[:space:]]*/[*])[[:space:]]*_UAPI@#\1 @
 39' $INFILE > $TMPFILE || exit 1
 40
 41scripts/unifdef -U__KERNEL__ -D__EXPORTED_HEADERS__ $TMPFILE > $OUTFILE
 42[ $? -gt 1 ] && exit 1
 43
 44# Remove /* ... */ style comments, and find CONFIG_ references in code
 45configs=$(sed -e '
 46:comment
 47	s:/\*[^*][^*]*:/*:
 48	s:/\*\*\**\([^/]\):/*\1:
 49	t comment
 50	s:/\*\*/: :
 51	t comment
 52	/\/\*/! b check
 53	N
 54	b comment
 55:print
 56	P
 57	D
 58:check
 59	s:^\(CONFIG_[[:alnum:]_]*\):\1\n:
 60	t print
 61	s:^[[:alnum:]_][[:alnum:]_]*::
 62	s:^[^[:alnum:]_][^[:alnum:]_]*::
 63	t check
 64	d
 65' $OUTFILE)
 66
 67# The entries in the following list do not result in an error.
 68# Please do not add a new entry. This list is only for existing ones.
 69# The list will be reduced gradually, and deleted eventually. (hopefully)
 70#
 71# The format is <file-name>:<CONFIG-option> in each line.
 72config_leak_ignores="
 73arch/arc/include/uapi/asm/page.h:CONFIG_ARC_PAGE_SIZE_16K
 74arch/arc/include/uapi/asm/page.h:CONFIG_ARC_PAGE_SIZE_4K
 75arch/arc/include/uapi/asm/swab.h:CONFIG_ARC_HAS_SWAPE
 76arch/arm/include/uapi/asm/ptrace.h:CONFIG_CPU_ENDIAN_BE8
 77arch/hexagon/include/uapi/asm/ptrace.h:CONFIG_HEXAGON_ARCH_VERSION
 78arch/hexagon/include/uapi/asm/user.h:CONFIG_HEXAGON_ARCH_VERSION
 79arch/ia64/include/uapi/asm/cmpxchg.h:CONFIG_IA64_DEBUG_CMPXCHG
 80arch/m68k/include/uapi/asm/ptrace.h:CONFIG_COLDFIRE
 81arch/nios2/include/uapi/asm/swab.h:CONFIG_NIOS2_CI_SWAB_NO
 82arch/nios2/include/uapi/asm/swab.h:CONFIG_NIOS2_CI_SWAB_SUPPORT
 83arch/x86/include/uapi/asm/auxvec.h:CONFIG_IA32_EMULATION
 84arch/x86/include/uapi/asm/auxvec.h:CONFIG_X86_64
 85arch/x86/include/uapi/asm/mman.h:CONFIG_X86_INTEL_MEMORY_PROTECTION_KEYS
 86include/uapi/linux/atmdev.h:CONFIG_COMPAT
 87include/uapi/linux/eventpoll.h:CONFIG_PM_SLEEP
 88include/uapi/linux/hw_breakpoint.h:CONFIG_HAVE_MIXED_BREAKPOINTS_REGS
 89include/uapi/linux/pktcdvd.h:CONFIG_CDROM_PKTCDVD_WCACHE
 90"
 91
 92for c in $configs
 
 
 
 
 
 
 
 
 
 93do
 94	leak_error=1
 95
 96	for ignore in $config_leak_ignores
 97	do
 98		if echo "$INFILE:$c" | grep -q "$ignore$"; then
 99			leak_error=
100			break
101		fi
102	done
103
104	if [ "$leak_error" = 1 ]; then
105		echo "error: $INFILE: leak $c to user-space" >&2
106		exit 1
107	fi
108done
109
110rm -f $TMPFILE
111trap - EXIT
v4.10.11
 1#!/bin/sh
 
 2
 3if [ $# -lt 2 ]
 4then
 5	echo "Usage: headers_install.sh OUTDIR SRCDIR [FILES...]"
 6	echo
 7	echo "Prepares kernel header files for use by user space, by removing"
 8	echo "all compiler.h definitions and #includes, removing any"
 9	echo "#ifdef __KERNEL__ sections, and putting __underscores__ around"
10	echo "asm/inline/volatile keywords."
11	echo
12	echo "OUTDIR: directory to write each userspace header FILE to."
13	echo "SRCDIR: source directory where files are picked."
14	echo "FILES:  list of header files to operate on."
15
16	exit 1
17fi
18
19# Grab arguments
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
 
20
21OUTDIR="$1"
22shift
23SRCDIR="$1"
24shift
25
26# Iterate through files listed on command line
27
28FILE=
29trap 'rm -f "$OUTDIR/$FILE" "$OUTDIR/$FILE.sed"' EXIT
30for i in "$@"
31do
32	FILE="$(basename "$i")"
33	sed -r \
34		-e 's/([ \t(])(__user|__force|__iomem)[ \t]/\1/g' \
35		-e 's/__attribute_const__([ \t]|$)/\1/g' \
36		-e 's@^#include <linux/compiler.h>@@' \
37		-e 's/(^|[^a-zA-Z0-9])__packed([^a-zA-Z0-9_]|$)/\1__attribute__((packed))\2/g' \
38		-e 's/(^|[ \t(])(inline|asm|volatile)([ \t(]|$)/\1__\2__\3/g' \
39		-e 's@#(ifndef|define|endif[ \t]*/[*])[ \t]*_UAPI@#\1 @' \
40		"$SRCDIR/$i" > "$OUTDIR/$FILE.sed" || exit 1
41	scripts/unifdef -U__KERNEL__ -D__EXPORTED_HEADERS__ "$OUTDIR/$FILE.sed" \
42		> "$OUTDIR/$FILE"
43	[ $? -gt 1 ] && exit 1
44	rm -f "$OUTDIR/$FILE.sed"
 
45done
 
 
46trap - EXIT